from blockchain import Blockchain
from simulate import Event
from utils import *

class Node:
    def __init__(self, sim, ID, bandwidth_type, cpu_type, Tk, T_tx, num_nodes):
        # Initialize node attributes
        self.sim = sim
        self.balance = 0
        self.nodeId = ID
        self.cpuType = cpu_type
        self.bandwidth_type = bandwidth_type
        self.Tk = Tk
        self.T_tx = T_tx
        self.num_nodes = num_nodes

        self.neighbors = []

        self.blockchain = Blockchain()
        self.pending_transactions = []

    def init_simulation(self):
        # Initialize simulation
        # schedule the first transaction
        self.sim.push_event(Event(self.sim.curr_time + sample_exponential(self.T_tx),\
                                  self.generate_random_transaction))
        pass
    def generate_random_transaction(self):
        # Generate a transaction for the given peer
        # Format: "TxnID: IDx pays IDy C coins"
        print("Generating a transaction for node", self.nodeId)  

        # Select a random destination node and amount
        dest = self.nodeId
        while dest == self.nodeId:
            dest = random.randint(0, self.num_nodes)
        amount = random.randint(1, self.balance + 10)
        txn = "TxnID: " + str(self.nodeId) + " pays " + str(dest) + " " + str(amount) + " coins"
        self.pending_transactions.append(txn)

        # schedule the next transaction
        self.sim.push_event(Event(self.sim.curr_time + sample_exponential(self.T_tx),\
                                  self.generate_random_transaction))
        pass
